//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.uds91.v0.std.10k.root")
//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.uds200.v0.std.10k.root")
//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.uds350.v0.std.10k.root")
//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.uds500.v0.std.10k.root")
//
//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.zh350.v0.std.10k.root")
//
//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.zz200.v0.std.10k.root")
//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.zz300.v0.std.10k.root")
//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.zz400.v0.std.10k.root")
//void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.zz500.v0.std.10k.root")
void PlotEcompoBP(const Char_t *fname = "results/jsf.pfoanl.zz700.v0.std.10k.root")
{
  // ------------------------------------------------------------
  //  Open shared libraries
  // ------------------------------------------------------------
  gSystem->Load("libJSF.so");
  gSystem->Load("libS4Utils.so");
  gSystem->Load("libAnlib.so");

  // ------------------------------------------------------------
  //  Open event file and apply cuts
  // ------------------------------------------------------------
  TFile *filep = TFile::Open(fname);
  TNtupleD *tupep = (TNtupleD *)gROOT->FindObject("hevt");

  //tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8&&mass>70&&mass<110","goff");
#if 0
  tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8","goff");
#else
  tupep->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.95&&abs(cosj2)<0.95","goff");
#endif
  TEventList *elistp = (TEventList *)gROOT->FindObject("elist");

  const Double_t kNsig = 2.;	// fit range for gaussian fit in units of sigma

  // ------------------------------------------------------------
  //  Define histograms
  // ------------------------------------------------------------
#if 0
  Double_t dEmin = -15.;
  Double_t dEmax = +15.;
  Double_t dEvmn = -20.;
  Double_t dEvmx = +20.;
  Double_t Emin  =   0.;
  Double_t Emax  = 100.;
  //Double_t Emax  = 180.;
#else
  Double_t dEmin = -30.;
  Double_t dEmax = +30.;
  Double_t dEvmn = -40.;
  Double_t dEvmx = +40.;
  Double_t Emin  =   0.;
  //Double_t Emax  = 500.;
  Double_t Emax  = 350.;
#endif
  TH1D *hDetkbp  = new TH1D("hDetkbp","",120,dEmin,dEmax);
  TH1D *hDeembp  = new TH1D("hDeembp","",120,dEmin,dEmax);
  TH1D *hDehdbp  = new TH1D("hDehdbp","",120,dEmin,dEmax);
  TH1D *hDevis   = new TH1D("hDevis" ,"",100,dEvmn,dEvmx);
  TH1D *hDecm    = new TH1D("hDecm"  ,"",100,dEvmn,dEvmx);
  TH1D *hEtkbp   = new TH1D("hEtkbp" ,"",100, Emin, Emax);
  TH1D *hEembp   = new TH1D("hEembp" ,"",100, Emin, Emax);
  TH1D *hEhdbp   = new TH1D("hEhdbp" ,"",100, Emin, Emax);
  TH1D *hEahbp   = new TH1D("hEahbp" ,"",100, Emin, Emax);
  //TH1D *hEahbp  = new TH1D("hEahbp" ,"",100, 0., 100.);
  TH1D *hEtotbp  = new TH1D("hEtotbp","",100, Emin, 2*Emax);
  TH1D *hEallbp  = new TH1D("hEallbp","",100, Emin, 2*Emax);

  // ------------------------------------------------------------
  //  Loop over selected events and fill up histograms
  // ------------------------------------------------------------
  Int_t nevt = elistp->GetN();
  cerr << "Nevt = " << nevt << endl;
#if 1
  Long64_t   *evlist = elistp->GetList();
  ofstream fevlist("fevlist");
  fevlist << nevt << endl;
  for (Int_t i=0; i<nevt; i++) {
     fevlist << evlist[i] << endl;
  }
#endif

  for (Int_t i=0; i<nevt; i++) {
    Int_t ievt = elistp->GetEntry(i);	// get event number

    Double_t npj1, npj2, cosj1, cosj2, mass;
    Double_t etk, eem, ehd, etkbp, eembp, ehdbp, eah, eahznu;

    tupep->SetBranchAddress("npj1",&npj1);
    tupep->SetBranchAddress("npj2",&npj2);
    tupep->SetBranchAddress("cosj1",&cosj1);
    tupep->SetBranchAddress("cosj2",&cosj2);
    tupep->SetBranchAddress("mass",&mass);
    tupep->SetBranchAddress("etk",&etk);
    tupep->SetBranchAddress("eem",&eem);
    tupep->SetBranchAddress("ehd",&ehd);
    tupep->SetBranchAddress("etkbp",&etkbp);
    tupep->SetBranchAddress("eembp",&eembp);
    tupep->SetBranchAddress("ehdbp",&ehdbp);
    tupep->SetBranchAddress("eah",&eah);
    if (tupep->FindBranch("eahznu")) tupep->SetBranchAddress("eahznu",&eahznu);
    else                         eahznu = 0.;

    tupep->GetEntry(ievt);	// get this event

    hDetkbp->Fill(etk-etkbp,1.);
    hDeembp->Fill(eem-eembp,1.);
    hDehdbp->Fill(ehd-ehdbp,1.);
    hDevis ->Fill(etk+eem+ehd-etkbp-eembp-ehdbp,1.);
    hDecm  ->Fill(etk+eem+ehd-etkbp-eembp-ehdbp-eah+eahznu,1.);
    hEtkbp ->Fill(etkbp,1.);
    hEembp ->Fill(eembp,1.);
    hEhdbp ->Fill(ehdbp,1.);
    hEahbp ->Fill(eah-eahznu,1.);
    hEtotbp->Fill(etkbp+eembp+ehdbp,1.);
    hEallbp->Fill(etkbp+eembp+ehdbp+eah-eahznu,1.);
  }
  // ------------------------------------------------------------
  //  Draw histograms
  // ------------------------------------------------------------
  gStyle->SetOptFit(1);
  gStyle->SetOptStat(111111);

  TCanvas *c1p = new TCanvas("c1","",20,20,1220,820);
  TCanvas &c1  = *c1p;
  c1.Divide(3,2);
  Int_t id = 0;

  TPad *cpadp;
#if 0
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDetkbp->Draw();
  ANLGaussFitter gfit(hDetkbp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDetkbp->SetFillColor(42);
  hDetkbp->SetFillStyle(1000);
  hDetkbp->GetXaxis()->SetTitle("#Delta E_{tk} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDeembp->Draw();
  ANLGaussFitter gfit(hDeembp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDeembp->SetFillColor(50);
  hDeembp->SetFillStyle(3001);
  hDeembp->GetXaxis()->SetTitle("#Delta E_{em} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDehdbp->Draw();
  ANLGaussFitter gfit(hDehdbp,kNsig);
  gfit.GetFunction()->Draw("same");
  hDehdbp->SetFillColor(9);
  hDehdbp->SetFillStyle(3002);
  hDehdbp->GetXaxis()->SetTitle("#Delta E_{hd} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDevis->Draw();
  ANLGaussFitter gfit(hDevis,kNsig);
  gfit.GetFunction()->Draw("same");
  hDevis->SetFillColor(50);
  hDevis->SetFillStyle(1000);
  hDevis->GetXaxis()->SetTitle("#Delta E_{vis} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hDecm->Draw();
  ANLGaussFitter gfit(hDecm,kNsig);
  gfit.GetFunction()->Draw("same");
  hDecm->SetFillColor(50);
  hDecm->SetFillStyle(1000);
  hDecm->GetXaxis()->SetTitle("E_{vis}-E_{cm} [GeV]");
#endif

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEtkbp->GetXaxis()->SetTitle("E_{tk} [GeV]");

  hEtkbp->SetFillColor(42);
  hEtkbp->SetFillStyle(3001);
  hEtkbp->Draw();
  hEtkbp->SetMaximum(1000);

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEembp->GetXaxis()->SetTitle("E_{EM} [GeV]");
  hEembp->SetFillColor(42);
  hEembp->SetFillColor(50);
  hEembp->SetFillStyle(3001);
  hEembp->Draw("same");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEhdbp->GetXaxis()->SetTitle("E_{HD} [GeV]");
  hEhdbp->SetFillColor(42);
  hEhdbp->SetFillColor(9);
  hEhdbp->SetFillStyle(3002);
  hEhdbp->Draw("same");

#if 1
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEahbp->SetFillColor(42);
  hEahbp->SetFillColor(38);
  hEahbp->SetFillStyle(3001);
  hEahbp->Draw("same");
#endif

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEtotbp->SetFillColor(42);
  hEtotbp->SetFillColor(38);
  hEtotbp->SetFillStyle(3001);
  hEtotbp->Draw("same");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEallbp->SetFillColor(42);
  hEallbp->SetFillColor(38);
  hEallbp->SetFillStyle(3001);
  hEallbp->Draw("same");

  c1.cd();
}
