void PlotNu(const Char_t *fname = "results/jsf.pfoanl.zh350.v0.std.10k.root")
//void PlotNu(const Char_t *fname = "results/jsf.pfoanl.zh350.v0.tkemhdexact.10k.root")
//void PlotNu(const Char_t *fname = "results/jsf.pfoanl.zh350.v0.emhdexact.10k.root")
//void PlotNu(const Char_t *fname = "results/jsf.pfoanl.zh350.v0.emexact.10k.root")
//void PlotNu(const Char_t *fname = "results/jsf.pfoanl.zh350.v0.hdexact.10k.root")
{
  // ------------------------------------------------------------
  //  Open shared libraries
  // ------------------------------------------------------------
  gSystem->Load("libJSF.so");
  gSystem->Load("libS4Utils.so");
  gSystem->Load("libAnlib.so");

  // ------------------------------------------------------------
  //  Open event file and apply cuts
  // ------------------------------------------------------------
  TFile *filep = TFile::Open(fname);
  TNtupleD *tupahp = (TNtupleD *)gROOT->FindObject("hah");

  //tupahp->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8&&mass>70&&mass<110","goff");
  tupahp->Draw(">>elist","npj1>=5&&npj2>=5&&abs(cosj1)<0.8&&abs(cosj2)<0.8","goff");
  TEventList *elistp = (TEventList *)gROOT->FindObject("elist");

  const Double_t kNsig = 2.;	// fit range for gaussian fit in units of sigma

  // ------------------------------------------------------------
  //  Define histograms
  // ------------------------------------------------------------
  Double_t Emin  =   0.;
  //Double_t Emax  = 500.;
  //Double_t Emax  = 200.;
  Double_t Emax  = 350.;

  TH1D *hEnunu = new TH1D("hEnunu" ,"",100, Emin, Emax);
  TH1D *hMnunu = new TH1D("hMnunu" ,"",100, Emin, Emax);
  TH1D *hEisr  = new TH1D("hEisr"  ,"",500, Emin, Emax);
  TH1D *hEah   = new TH1D("hEah"   ,"",500, Emin, Emax);
  TH1D *hEahnu = new TH1D("hEahnu" ,"",500, Emin, Emax);
  TH1D *hNnu   = new TH1D("hNnu"   ,"", 10,   0.,  10.);
  TH1D *hPID   = new TH1D("hPID"   ,"",100, -50.,  50.);
  TH1D *hPPID  = new TH1D("hPPID"  ,"",100, -50.,  50.);

  // ------------------------------------------------------------
  //  Loop over selected events and fill up histograms
  // ------------------------------------------------------------
  Int_t nah = elistp->GetN();
  cerr << "Nah = " << nah << endl;
  Double_t evs   = -1;
  Double_t Eisr  = 0;
  Double_t Enu   = 0;
  Double_t Eah   = 0;
  Double_t Eahnu = 0;
  Double_t Pxnu  = 0;
  Double_t Pynu  = 0;
  Double_t Pznu  = 0;
  Double_t Nnu   = 0;

  for (Int_t i=0; i<nah; i++) {
    Int_t iah = elistp->GetEntry(i);	// get undetected particle number

    Double_t ev, npj1, npj2, cosj1, cosj2, evis, mass;
    Double_t ch, pid, ppid, e, px, py, pz;

    tupahp->SetBranchAddress("ev",&ev);
    tupahp->SetBranchAddress("npj1",&npj1);
    tupahp->SetBranchAddress("npj2",&npj2);
    tupahp->SetBranchAddress("cosj1",&cosj1);
    tupahp->SetBranchAddress("cosj2",&cosj2);
    tupahp->SetBranchAddress("evis",&evis);
    tupahp->SetBranchAddress("mass",&mass);
    tupahp->SetBranchAddress("ch",&ch);
    tupahp->SetBranchAddress("pid",&pid);
    tupahp->SetBranchAddress("ppid",&ppid);
    tupahp->SetBranchAddress("e",&e);
    tupahp->SetBranchAddress("px",&px);
    tupahp->SetBranchAddress("py",&py);
    tupahp->SetBranchAddress("pz",&pz);

    tupahp->GetEntry(iah);	// get this event

#if 0
    hPID ->Fill(pid ,1.);
    hPPID->Fill(ppid,1.);
#endif
    Double_t apid  = TMath::Abs(pid);
    Double_t appid = TMath::Abs(ppid);

    if (evs != -1 && ev != evs) {
      hEisr ->Fill(Eisr,1.);
      hEnunu->Fill(Enu,1.);
      Double_t Mnu = TMath::Sqrt(Enu*Enu - Pxnu*Pxnu - Pynu*Pynu - Pznu*Pznu);
      hMnunu->Fill(Mnu,1.);
      hNnu  ->Fill(Nnu,1.);
      hEah  ->Fill(Eah,1.);
      hEahnu->Fill(Eahnu,1.);
      Eisr  = 0;
      Enu   = 0;
      Eah   = 0;
      Eahnu = 0;
      Pxnu  = 0;
      Pynu  = 0;
      Pznu  = 0;
      Nnu   = 0;
    }
    if (TMath::Abs(appid-23)<0.1 && (TMath::Abs(apid-12.)<0.5 || TMath::Abs(apid-14.)<0.5 || TMath::Abs(apid-16.)<0.5)) {
#if 1
      hPID ->Fill(pid ,1.);
      hPPID->Fill(ppid,1.);
#endif
      Enu  += e;
      Pxnu += px;
      Pynu += py;
      Pznu += pz;
      Nnu++;
    } else {
      Eah += e;
      if (TMath::Abs(apid-12.)<0.5 || TMath::Abs(apid-14.)<0.5 || TMath::Abs(apid-16.)<0.5) {
        Eahnu += e;
      } else if (TMath::Abs(appid-22.)<0.1) {
        Eisr += e;
      }
    }
    evs  = ev;
  }
  hEisr->Fill(Eisr,1.);
  hEnunu->Fill(Enu,1.);
  Double_t Mnu = TMath::Sqrt(Enu*Enu - Pxnu*Pxnu - Pynu*Pynu - Pznu*Pznu);
  hMnunu->Fill(Mnu,1.);
  hNnu  ->Fill(Nnu,1.);
  hEah  ->Fill(Eah,1.);
  hEahnu->Fill(Eahnu,1.);

  // ------------------------------------------------------------
  //  Draw histograms
  // ------------------------------------------------------------
  gStyle->SetOptFit(1);
  gStyle->SetOptStat(111111);

  TCanvas *c1p = new TCanvas("c1","",20,20,1220,820);
  TCanvas &c1  = *c1p;
  c1.Divide(3,2);
  Int_t id = 0;

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEnunu->Draw();
  ANLGaussFitter gfit(hEnunu,kNsig);
  gfit.GetFunction()->Draw("same");
  hEnunu->SetFillColor(9);
  hEnunu->SetFillStyle(3002);
  hEnunu->GetXaxis()->SetTitle("#E_{#nu#nu} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hMnunu->Draw();
  ANLGaussFitter gfit(hMnunu,kNsig);
  gfit.GetFunction()->Draw("same");
  hMnunu->SetFillColor(50);
  hMnunu->SetFillStyle(1000);
  hMnunu->GetXaxis()->SetTitle("M_{#nu#nu} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hNnu->Draw();
  hNnu->SetFillColor(50);
  hNnu->SetFillStyle(1000);
  hNnu->GetXaxis()->SetTitle("N_{nu}");

#if 0
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hPID->Draw();
  hPID->SetFillColor(50);
  hPID->SetFillStyle(1000);
  hPID->GetXaxis()->SetTitle("PID");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hPPID->Draw();
  hPPID->SetFillColor(50);
  hPPID->SetFillStyle(1000);
  hPPID->GetXaxis()->SetTitle("PPID");
#else
  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEisr->Draw();
  hEisr->SetFillColor(50);
  hEisr->SetFillStyle(1000);
  hEisr->GetXaxis()->SetTitle("E_{ISR} [GeV]");
#endif

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEah->Draw();
  hEah->SetFillColor(50);
  hEah->SetFillStyle(1000);
  hEah->GetXaxis()->SetTitle("E_{ah} [GeV]");

  id++; cpadp = (TPad *)c1.cd(id);
  cpadp->SetFillColor(30);
  cpadp->SetFrameFillColor(TColor::GetColor("#fbf7ca"));
  hEahnu->Draw();
  hEahnu->SetFillColor(50);
  hEahnu->SetFillStyle(1000);
  hEahnu->GetXaxis()->SetTitle("E_{#nu in ah} [GeV]");

  c1.cd();
}
