#ifndef __JSFJUPITER__
#define __JSFJUPITER__

///////////////////////////////////////////////////////////////////////
//
//  JSF-G4 interface
//
//
//$Id: JSFJupiter.h,v 1.2 2006/08/15 07:16:21 miyamoto Exp $
//
///////////////////////////////////////////////////////////////////////

#include <TObject.h>
#include <TMap.h>
#include <TString.h>
#include <TTree.h>
#include "JSFJ4.h"

class JSFJ4RunManager;
class G4VisManager;
class G4UImanager;

class J4DetectorConstruction;
class J4Output;

class S4CALTowerGeom;

// *******************************************************
class JSFJupiter : public JSFJ4
{
 protected:
  Int_t fNcall;
  Int_t fNgood;
  S4CALTowerGeom  *fCALTowerGeom;  // CAL Tower Geometry  

  JSFJ4RunManager *fRunManager;  //!
  G4VisManager *fVisManager;  //!
  G4UImanager  *fUImanager;   //!

  Bool_t  fUseJupiterGenerator;  // JSFGenerator(false) or Jupiter generator(true)
  TString fInitMacro;

  // Pointers to the detector
  J4DetectorConstruction *fpDetector;  //!

 public:
  JSFJupiter(const char *name="JSFJupiter",
		  const char *title="JSFJupiter");
  virtual ~JSFJupiter();

  void BuildJupiter();

  inline JSFJ4RunManager *GetRunManager(){ return fRunManager; }

  inline S4CALTowerGeom *GetCALTowerGeom(){ return fCALTowerGeom;}

// fCALTowerGeom is valid only after JSFJ4::Initialize() 
  virtual Bool_t Initialize();
  virtual Bool_t BeginRun(Int_t irun=1);
  virtual Bool_t Process(Int_t ev=1);
  virtual Bool_t EndRun();
  virtual Bool_t Terminate();

  ClassDef(JSFJupiter, 1)  // JSFJupiter class

};

#endif










