///////////////////////////////////////////////////////////////////
//
//  JSFJ4 Primary vertex class
//
//$Id: S4PrimaryVertex.cxx,v 1.1 2005/04/01 11:25:39 fujiik Exp $
//
//////////////////////////////////////////////////////////////////


#include "S4PrimaryParticle.h"
#include "S4PrimaryVertex.h"
#include "G4PrimaryParticle.hh"
#include "G4PrimaryVertex.hh"
using namespace std;


ClassImp(S4PrimaryVertex)

// ------------------------------------------------------------------
S4PrimaryVertex::S4PrimaryVertex():
  fSerialNo(0), fT0(0), fWeight(0), fPosition(0.0, 0.0, 0.0),
  fParticles(0), fNextVertex(0)
{
}

// ------------------------------------------------------------------
S4PrimaryVertex::S4PrimaryVertex(G4PrimaryVertex *v, Int_t ser):
  fSerialNo(ser), fT0(0), fWeight(0), fPosition(0.0, 0.0, 0.0),
  fParticles(0), fNextVertex(0)
{
  fT0=v->GetT0();
  fWeight=v->GetWeight();
  fPosition=TVector3(v->GetX0(), v->GetY0(), v->GetZ0());

  fParticles = new TObjArray() ;

}

// ------------------------------------------------------------------
S4PrimaryVertex::~S4PrimaryVertex()
{
  if( fParticles ) {
     fParticles->Delete();
     delete fParticles;
  }
}

// ------------------------------------------------------------------
void S4PrimaryVertex::Print(Option_t *opt)
{
  cout << " Position(" << GetPosition().X();
  cout << "," << GetPosition().Y() << "," << GetPosition().Z() << ")" ;
  
  cout << " SerialNo=" << GetSerialNo();
  cout << " T0=" << GetT0() ;
  cout << " Weight=" << GetWeight();
  cout << " Number of particles =" << GetNumberOfParticles();
  cout << endl;

  if( strcmp(opt,"") != 0 ) {
    for(Int_t ip=0;ip<fParticles->GetEntries();ip++){
      S4PrimaryParticle *p=(S4PrimaryParticle*)fParticles->UncheckedAt(ip);
      p->Print();
    }
  }

}
