#ifndef __S4TPCMCTRUTHBUF__
#define __S4TPCMCTRUTHBUF__
//*************************************************************************
//* ----------------
//* S4VMCTruthBuf Class
//* ----------------
//* (Description)
//*	This set of classes reads ascii output of JUPITER and
//*	put them into root objects.
//* (Requires)
//*	S4VMCTruthBuf:
//* (Provides)
//*	S4VMCTruthBuf		: steering class
//* (Update Record)
//*	2004/09/06  A.Yamaguchi	Original version.
//*************************************************************************

#include "S4VMCTruthBuf.h"
#include "S4TPCTypeDef.h"
#include "S4TPCMCTruth.h"

// ---------------
// MonteCarlo Truth Buffer
// ---------------

class S4TPCMCTruthBuf : public S4VMCTruthBuf {

public:
  S4TPCMCTruthBuf(const Char_t *name  = "S4TPCMCTruthBuf",
                  const Char_t *title = "TPC MCTruth Buf", 
                  S4TPCMCTruth *mod =0,
		  Int_t         bufsize = 20000);

  S4TPCMCTruthBuf(S4TPCMCTruth *mod,
                  const Char_t *name = "S4TPCMCTruthBuf",
		  const Char_t *title = "TPC MCTruth Buf",
                  Int_t         bufsize = 20000);

  virtual   ~S4TPCMCTruthBuf();

  TObjArray *GetPostHitsPtr()                { return fPostHitsPtr; }
  TObjArray *GetInputBufPtr()                { return fInputBufPtr; }
  void       SetPostHitsPtr(TObjArray *bufp) { fPostHitsPtr = bufp; }
  void       SetInputBufPtr(TObjArray *bufp) { fInputBufPtr = bufp; }
  void       MergeHits();

  Bool_t     ReadFile();

private:
  void       CleanUp(TObjArray &obp);       

private:
  TObjArray *fPostHitsPtr;             //!
  TObjArray *fInputBufPtr;             //! 
  
  ClassDef(S4TPCMCTruthBuf, 1) // TPC raw data buffer
};

#endif

