#ifndef __S4TPCPOSTHIT__
#define __S4TPCPOSTHIT__
//*************************************************************************
//* --------------------
//* S4TPCPostHit
//* --------------------
//* (Description)
//*	TPC Hit class.
//*	Mother class : TObject
//*     
//* (Update Record)
//*	2001/03/15  K.Hoshina	Original version.
//*************************************************************************

#include <iostream>
#include <iomanip>

#include "TObject.h"
#include "TVector3.h"

#include "S4VExactHit.h"

class J4TPCPostHit;

class S4TPCPostHit : public S4VExactHit {

public:
    
  S4TPCPostHit() { } 

  S4TPCPostHit(const J4TPCPostHit *hitp);

  S4TPCPostHit(       Int_t     evtID      ,
                      Int_t     trackID    ,
                      Int_t     mothertrkID,
                      Int_t     hitID      ,
                      Int_t     pcode      ,
                      Int_t     charge     ,
                const TVector3 &pos        ,
                const TVector3 &momentum   ,
                      Double_t  totE       ,
                      Double_t  tof);


  virtual ~S4TPCPostHit();
  
#if 0
  static void	SetSortBy(Char_t *opt = "TrackID");
  Bool_t	IsSortable() const;
  Int_t         Compare(const TObject *obj) const;  
#endif
  
  virtual void DebugPrint(const Option_t *opt = "");
  
  //Get method -----------//
  //Set method -----------//
private:

  //virtual void CalcHitCoord();
  
private:
  static Int_t	fTPCPostHitSortBy; //!
  
  	
  ClassDef(S4TPCPostHit, 2) // Datum of TPC Hits
};


#endif
