//*************************************************************************
//* --------------------
//* U4VHitMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2002/08/27  R.Kuboshima
//*************************************************************************

#include <iostream>
#include "S4BabyHitMakerBuf.h"
#include "JSFSteer.h"

#define __TMP__

ClassImp(S4BabyHitMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4BabyHitMaker::S4BabyHitMaker(U4CDCTimeToXRelation *calib,
			       const char *name, const char *title)
              : U4CDCHitMaker(calib, name,title)
{
}
         
//=====================================================================
//* destructor --------------------------------------------------------

S4BabyHitMaker::~S4BabyHitMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t S4BabyHitMaker::Initialize()
{
	std::cerr << " S4BabyHitMaker::Initialize called" << std::endl;
#ifndef __TMP__
	if (!fCalibPtr) {
		fCalibPtr = new U4BabyTimeToXRelation();
		fToDeleteCalib = kTRUE;
	}
#endif
	fEventBuf = new S4BabyHitMakerBuf(this,GetCalibPtr());
	
	return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4BabyHitMaker::Process(Int_t ev)
{
	
	S4VMCTruth *mctp
		= (S4VMCTruth*)gJSF->FindModule("S4BabyMCTruth");
	S4VMCTruthBuf *mctbufp = (S4VMCTruthBuf *)mctp->EventBuf();

	S4BabyHitMakerBuf* hmbufp = (S4BabyHitMakerBuf *)EventBuf();
	hmbufp->SetInputDataBufPtr(mctbufp);	
	hmbufp->MakeHits();

	return kTRUE;
}







