#ifndef __S4BabyHITMAKERBUF__
#define __S4BabyHITMAKERBUF__

//*************************************************************************
//* ---------------------
//* S4BabyHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4BabyHitMakerBuf		: buffering class
//* (Update Record)
//*	2002/08/27  R.Kuboshima
//*************************************************************************

#include "U4CDCHitMakerBuf.h"
#include "S4BabyHitMaker.h"


class S4BabyHitMakerBuf : public U4CDCHitMakerBuf {
friend class S4BabyHitMaker;

public:

  S4BabyHitMakerBuf(U4CDCTimeToXRelation *calib = 0,
  	           const char *name="S4BabyHitMakerBuf",
	           const char *title="Baby Hit data", 
	           S4BabyHitMaker *module=0, Int_t bufsize = 50);
  S4BabyHitMakerBuf(S4BabyHitMaker *module,
  	           U4CDCTimeToXRelation *calib,
	           const char *name="S4BabyHitMakerBuf",
	           const char *title="Baby Hit data",
	           Int_t bufsize = 50);
		    
  virtual ~S4BabyHitMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "")
                                { U4CDCHitMakerBuf::DebugPrint(); }
    
protected:  
  virtual void	MakeHits() ;	// Make Baby Hits
  
private:
  void AppendCell  (TObjArray* celltmpp,  U4CDCHitLayer* layercurp);
  void AppendLayer (TObjArray* layertmpp, TObjArray* outputbufp);
  
  
  ClassDef(S4BabyHitMakerBuf, 1) // Cluster data buffer
};



#endif













