//*************************************************************************
//* --------------------
//* U4VHitMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2001/08/22  K.Hoshina	Original version.
//*************************************************************************

#include <iostream>
#include "S4CDCHitMakerBuf.h"
#include "JSFSteer.h"


ClassImp(S4CDCHitMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4CDCHitMaker::S4CDCHitMaker(U4CDCTimeToXRelation *calib,
			       const char *name, const char *title)
              : U4CDCHitMaker(calib, name,title)
{
}
         
//=====================================================================
//* destructor --------------------------------------------------------

S4CDCHitMaker::~S4CDCHitMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t S4CDCHitMaker::Initialize()
{
        U4CDCHitMaker::Initialize();
        if (fEventBuf) delete fEventBuf;

        fEventBuf = new S4CDCHitMakerBuf(this,GetCalibPtr());

	return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4CDCHitMaker::Process(Int_t ev)
{
   S4CDCHitMakerBuf* hmbufp = (S4CDCHitMakerBuf *)EventBuf();
   S4VMCTruth    *mctp = (S4VMCTruth*)gJSF->FindModule("S4CDCMCTruth","quiet");
   S4VMCTruthBuf *mctbufp = (S4VMCTruthBuf *)mctp->EventBuf();
   hmbufp->SetInputDataBufPtr(mctbufp);	
   hmbufp->fInputBufPtr = mctbufp->GetExactHitsPtr();

   hmbufp->MakeHits();

   return kTRUE;
}
