//*************************************************************************
//* --------------------
//* S4CDCTrackMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2001/08/22  K.Hoshina	Original version.
//*************************************************************************

#include "S4CDCTrackMaker.h"
#include "S4CDCTrackMakerBuf.h"
#include "S4CDCHitMakerBuf.h"
#include "JSFSteer.h"


ClassImp(S4CDCTrackMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4CDCTrackMaker::S4CDCTrackMaker(U4CDCKalDetector *det,
                                 const char *name, const char *title)
                : U4CDCTrackMaker(name,title) , fDetectorPtr(det)
{ 
}
         
//=====================================================================
//* destructor --------------------------------------------------------

S4CDCTrackMaker::~S4CDCTrackMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t S4CDCTrackMaker::Initialize()
{
   std::cerr <<" S4CDCTrackMaker Initialize called" << std::endl;
   fEventBuf = new S4CDCTrackMakerBuf(this);

   return kTRUE;
}

//=====================================================================
//* BeginRun() ------------------------------------------------------

Bool_t S4CDCTrackMaker::BeginRun(Int_t run)
{
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4CDCTrackMaker::Process(Int_t ev)
{
   S4CDCHitMaker      *hmp    = (S4CDCHitMaker *)gJSF->FindModule("S4CDCHitMaker");
   S4CDCHitMakerBuf   *hmbufp = (S4CDCHitMakerBuf *)hmp->EventBuf();

   S4CDCTrackMakerBuf *tmbufp = (S4CDCTrackMakerBuf *)EventBuf();
   tmbufp->SetInputDataBufPtr(hmbufp);
   tmbufp->MakeTracks();

   return kTRUE;
}
