#ifndef __S4CDCTRACKMAKERBUF__
#define __S4CDCTRACKMAKERBUF__

//*************************************************************************
//* ---------------------
//* S4CDCTrackMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	S4CDCTrackMakerBuf		: buffering class
//* (Update Record)
//*	1999/12/04  K.Fujii	Original version.
//*************************************************************************

#include "U4CDCTrackMakerBuf.h"
#include "S4CDCTrackMaker.h"
#include "S4CDCTrack.h"
#include "S4CDCVectorHit.h"

class S4CDCTrackMakerBuf : public U4CDCTrackMakerBuf {
friend class S4CDCTrackMaker;

public:

  S4CDCTrackMakerBuf(const char *name="S4CDCTrackMakerBuf",
	           const char *title="CDC Track data", 
	           S4CDCTrackMaker *module=0, Int_t bufsize = 2000);
  S4CDCTrackMakerBuf(S4CDCTrackMaker *module,
	             const char *name="S4CDCTrackMakerBuf",
	             const char *title="CDC Track data",
	             Int_t bufsize = 2000);
		    
  virtual ~S4CDCTrackMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "") {}
    
protected:  
  virtual void	MakeTracks() ;	// Make CDC Tracks
    
private:
  void AppendVectorHit(TObjArray* vectorhittmpp,  S4CDCTrack* trackcurp);
  void AppendTrack    (TObjArray* tracktmpp, TObjArray* outputbufp);
  S4CDCTrack *FindTrackByNo(Int_t trackno);
  
  ClassDef(S4CDCTrackMakerBuf, 1) // Cluster data buffer
};



#endif
