//*************************************************************************   
//* ---------------------                      
//* S4Jet Class
//* ---------------------   
//* (Description) 
//*     represent Jet.
//* (Requires)
//*     S4PFObject
//* (Provides)  
//*     S4Jet            : made object class
//* (Update Record)
//*     2004/10/05  S.Yamamoto  Original version.
//*     2004/11/04  K.Fujii     Modified to use TAttDrawable.
//*************************************************************************

#include "S4PFObject.h"
#include "S4Jet.h"
#include "TVirtualPad.h"

#include <iostream>

ClassImp(S4Jet)

//=====================================================================
//* constructor -------------------------------------------------------
S4Jet::S4Jet()
{
}

S4Jet::S4Jet(const ANLJet &jet)
           : ANLJet(jet)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4Jet::~S4Jet()
{
}

//=====================================================================
//* DebugPrint --------------------------------------------------------  
                                          
void S4Jet::DebugPrint(const Char_t *) const
{ 
   ANLJet::DebugPrint();
}
//=====================================================================
//* Draw --------------------------------------------------------------  
                                          
void S4Jet::Draw(Int_t color, const Char_t *opt)
{ 
   const TObjArray &pfos = GetParticlesInJet();
   if (!gPad || !pfos.GetEntries()) return;

   TIter next(&pfos);
   TAttDrawable *objp = 0;
   while ((objp = dynamic_cast<TAttDrawable *>(next()))) {
      objp->Draw(color, opt);
   }
}
