#ifndef __S4PFOFILTER__
#define __S4PFOFILTER__

//*************************************************************************
//* ---------------------
//* S4PFOFileter Class
//* ---------------------
//* (Description)
//*	This set of classes makes Particle Flow Objects.
//* (Requires)
//*	
//* (Provides)
//*	S4PFOFileter		: steering class
//* (Update Record)
//*	2004/11/15  S.Yamamoto	Original version.
//*************************************************************************

#include "TObject.h"

class S4PFObject;

class S4PFOFilter : public TObject {

public:
   S4PFOFilter(Double_t emin = 0.05);
   virtual ~S4PFOFilter();

   virtual Bool_t IsOK(const S4PFObject &pfo); // validate pfo

 private:
   Double_t fEmin;            // filter cut[GeV]  

   ClassDef(S4PFOFilter, 1)           //  PFO filter
};

#endif

