//*************************************************************************
//* ---------------------
//* S4TPCTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single hit.
//* (Requires)
//*	TObject
//* (Provides)
//*	S4TPCTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "S4TPCTrackHit.h"

ClassImp(S4TPCTrackHit)


//=====================================================================
//* constructor -------------------------------------------------------

S4TPCTrackHit::S4TPCTrackHit()
{
}

S4TPCTrackHit::S4TPCTrackHit(S4TPCHit *ht)
             : U4TPCTrackHit(ht)
{
}

S4TPCTrackHit::S4TPCTrackHit(const S4TPCTrackHit &ht)
             : U4TPCTrackHit(ht)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

S4TPCTrackHit::~S4TPCTrackHit()
{
}

//=====================================================================
//* destructor --------------------------------------------------------

void S4TPCTrackHit::SetSortBy(Char_t *opt )
{
   switch (opt[2]) {
      case 'm':       // sort by "Time"
      default:
         U4VTrackHit::SetSortBy(0);
         break;
   }
}

Int_t S4TPCTrackHit::Compare(const TObject *obj) const
{
   switch (GetSortBy()) {
      case 0: 
      default: {
         Double_t tof  = const_cast<S4TPCTrackHit *>(this)
                              ->GetHitPtr()->GetExactHitPtr()->GetTOF();
         Double_t tofo = ((S4TPCTrackHit *)obj)
                              ->GetHitPtr()->GetExactHitPtr()->GetTOF();
         return (tof < tofo ? -1 : (tof > tofo ? 1 : 0));
         break;
      }
   }
}

