//*************************************************************************
//* --------------------
//* U4VHitMaker
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/12/15  T.Fujikawa	Original version.
//*************************************************************************

#include <iostream>
#include "S4VTXMCTruthBuf.h"
#include "S4VTXHitMakerBuf.h"
#include "JSFSteer.h"
//#define __DEBUG__

using namespace std;

ClassImp(S4VTXHitMaker)

//=====================================================================
//* constructor -------------------------------------------------------

S4VTXHitMaker::S4VTXHitMaker(const Char_t *name, const Char_t *title)
             : U4VTXHitMaker(name,title)
{
#ifdef __DEBUG__
   cerr << " constructor for S4VTXHitMaker is called..." << endl;
#endif
}
         
//=====================================================================
//* destructor --------------------------------------------------------

S4VTXHitMaker::~S4VTXHitMaker()
{
}

//=====================================================================
//* Initialize() ------------------------------------------------------

Bool_t S4VTXHitMaker::Initialize()
{
#ifdef __DEBUG__
   cerr << "S4VTXHitMaker::Initialize() is called..." << endl;
#endif

   fEventBuf = new S4VTXHitMakerBuf(this);
   return kTRUE;
}

//=====================================================================
//* Process -----------------------------------------------------------

Bool_t S4VTXHitMaker::Process(Int_t /*ev*/)
{
#ifdef __DEBUG__
   cerr << " S4VTXHitMaker::Process() is called..." << endl;
#endif
   JSFModule *mctp = gJSF->FindModule("S4VTXMCTruth","quiet");
   if (!mctp) return kTRUE;
   S4VTXMCTruthBuf *mctbufp = static_cast<S4VTXMCTruthBuf *>(mctp->EventBuf());
   S4VTXHitMakerBuf *hmbufp = static_cast<S4VTXHitMakerBuf *>(EventBuf());

   hmbufp->SetInputDataBufPtr(mctbufp);	
   hmbufp->SetInputBufPtr(mctbufp->GetExactHitsPtr());

   hmbufp->MakeHits();

   return kTRUE;

}
