//*************************************************************************
//* --------------------
//* S4VTXHitMakerBuf
//* --------------------
//* (Description)
//*	This set of classes makes pad hits.
//* (Requires)
//* (Provides)
//* (Update Record)
//*	2004/12/15  T.Fujikawa	Original version.
//*************************************************************************

#include <iostream>
#include "S4VTXHitMakerBuf.h"
#include "S4VTXExactHit.h"
#include "S4VTXHit.h"
using namespace std;

//#define __DEBUG__


ClassImp(S4VTXHitMakerBuf)

//=====================================================================
//* constructor -------------------------------------------------------
S4VTXHitMakerBuf::S4VTXHitMakerBuf(const Char_t  *name,
                                   const Char_t  *title,
                                   S4VTXHitMaker *module,
                                   Int_t          bufsize)
                : U4VTXHitMakerBuf(name, title, module, bufsize),
                  fInputBufPtr(0)
{
#ifdef __DEBUG__
   cerr << " constructor for S4VTXHitMakerBuf is called..." << endl;
#endif
}          
          
S4VTXHitMakerBuf::S4VTXHitMakerBuf(S4VTXHitMaker *module,
                                   const Char_t  *name,
                                   const Char_t  *title, 
                                   Int_t          bufsize)
                : U4VTXHitMakerBuf(module, name, title, bufsize),
                  fInputBufPtr(0)
{
#ifdef __DEBUG__
   cerr << " constructor for S4VTXHitMakerBuf is called..." << endl;
#endif
}          

//=====================================================================
//* destructor --------------------------------------------------------

S4VTXHitMakerBuf::~S4VTXHitMakerBuf()
{
}


//=====================================================================
//* MakeHits ----------------------------------------------------------

void S4VTXHitMakerBuf::MakeHits()
{
#ifdef __DEBUG__
   cerr << " S4VTXHitMakerBuf::MakeHits() is called..." << endl;
#endif

   if (!fInputBufPtr) {
      cerr << "ERROR  S4VTXHitMakerBuf::MakeHits"        << endl
           << "...... cluster data not yet initialized." << endl;
      return;
   }
   else if (IsDone()) return;

   SetDone(kTRUE);

   TIter next(fInputBufPtr);
   S4VTXExactHit *exacthitp;
   while ((exacthitp = dynamic_cast<S4VTXExactHit *> (next()))) {
      S4VTXHit *hitp = new S4VTXHit(exacthitp);
      GetOutputBufPtr()->Add(hitp);

#ifdef __DEBUG__
      hitp->DebugPrint();
#endif

   }
}
