#ifndef __U4CDCHITCELL__
#define __U4CDCHITCELL__

//*************************************************************************
//* ---------------------
//* U4CDCHitCell Class
//* ---------------------
//* (Description)
//*	Class to store "U4CDCHitWire"s for a single cell.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4CDCHitCell		: Array containing "U4CDCHitWire"s
//* (Update Record)
//*	1999/12/04  K.Fujii	Original version.
//*************************************************************************

class U4CDCHitLayer;
class U4CDCHitWire;
class U4CDCCluster;

#include "U4CDCHitLayer.h"
#include "U4CDCHitWire.h"

class U4CDCHitCell : public TObjArray {
friend class U4CDCHitLayer;

public:
  U4CDCHitCell();
  virtual ~U4CDCHitCell();

  inline virtual U4CDCHitLayer *GetLayerPtr() const { return fLayerPtr; }

  inline virtual Int_t	GetLayerNumber() const { return fLayerNumber; }
  inline virtual Int_t	GetCellNumber () const { return fCellNumber;  }

  virtual Int_t		Append(U4CDCHitWire *wire);

  virtual Bool_t	IsSortable() const;
  virtual Int_t		Compare(const TObject *obj) const;

  virtual void 		DebugPrint(const Char_t *opt = "Brief");

private:
  Int_t		 fLayerNumber;	// layer Number.
  Int_t		 fCellNumber;	// cell Number.
  U4CDCHitLayer *fLayerPtr;	// pointer to layer this belongs to
 
  ClassDef(U4CDCHitCell, 1) 	// CDC Hit Cell
};

#endif

