#ifndef __U4ITKALDETECTOR__
#define __U4ITKALDETECTOR__
//*************************************************************************
//* ===================
//*  U4ITKalDetector Class
//* ===================
//*
//* (Description)
//* (Requires)
//* (Provides)
//* (Update Recored)
//*   2004/12/16  A.Yamaguchi       Original version.
//*
//*************************************************************************

#include "U4VKalDetector.h"
#include "U4ITMeasLayer.h"

class U4ITKalDetector : public U4VKalDetector {
public:
   U4ITKalDetector(Int_t n = 1);  
   U4ITKalDetector(const TString &flag, Int_t n = 1);  
   virtual ~U4ITKalDetector(); 

   virtual void Initialize();

   const U4VMeasLayer *GetMeasLayerPtr(Int_t index) const;

   inline void   FBOn  ()       { fIsFBOn = kTRUE;  }
   inline void   FBOff ()       { fIsFBOn = kFALSE; }
   inline Bool_t IsFBOn() const { return fIsFBOn;   }

   ClassDef(U4ITKalDetector,1)      // Sample hit class

private:
   Bool_t fIsFBOn;
};

#endif

