#ifndef __U4ITHIT__
#define __U4ITHIT__
//*************************************************************************
//* ---------------------
//* U4ITKalHit Class
//* ---------------------
//* (Description)
//* (Requires)
//*     TObjArray
//* (Provides)
//* (Update Record)
//*     2004/08/26  A.Yamaguchi    Original Ver.
//*************************************************************************

#include "U4VKalHit.h"
#include "U4ITMeasLayer.h"

class U4ITKalHit : public U4VKalHit {
public:
   U4ITKalHit(Int_t m = kMdim);
   U4ITKalHit(const TObject       &hit,
              const U4ITMeasLayer &ms,
                    Double_t      *x,
                    Double_t      *dx,
                    Double_t       b,
                    Int_t          m = kMdim);
   U4ITKalHit(const U4ITKalHit &hit);
   ~U4ITKalHit();

   virtual TKalMatrix XvToMv(const TVector3 &xv, Double_t t0) const;

   virtual void       DebugPrint(Option_t *opt = "") const;

private:

   ClassDef(U4ITKalHit,1)      // Sample hit class
};

#endif

