//*************************************************************************
//* ---------------------
//* U4ITHit Class
//* ---------------------
//* (Description)
//*	Class for a single IT hit.
//* (Requires)
//*	TObject
//* (Provides)
//*	U4ITHit		: TObject containing single hit data
//* (Update Record)
//*	2004/08/07  A.Yamaguchi	Original version.
//*************************************************************************

#include <iostream>
#include "U4ITHit.h"

ClassImp(U4ITHit)
	
Int_t U4ITHit::fgITHitSortBy = 0;

//=====================================================================
//* constructor -------------------------------------------------------

U4ITHit::U4ITHit(Int_t    layerID,
                 Int_t    side,
                 Double_t x1,
                 Double_t x2)
       : fDone(kFALSE),
         fX1(x1),
         fDX1(0.),
         fX2(x2),
         fDX2(0.),
         fLayerID(layerID),
         fSide(side)
{
}

//=====================================================================
//* destructor --------------------------------------------------------

U4ITHit::~U4ITHit() 
{	
}

//=====================================================================
//* SetSortBy --------------------------------------------------------
                                                                                
void U4ITHit::SetSortBy(Char_t *opt)
{
   switch (opt[2]) {
      case 'y':    // sort by layer ID
      default:
         fgITHitSortBy = 0;
         break;
   }
}

//=====================================================================
//* IsSortable --------------------------------------------------------

Bool_t U4ITHit::IsSortable() const
{
   return kTRUE;
}

//=====================================================================
//* Compare -----------------------------------------------------------
                                                                                
Int_t U4ITHit::Compare(const TObject *obj) const
{
   switch (fgITHitSortBy) {
      case 0:
      default: {
         Int_t radius  = GetLayerID();
         Int_t radiuso = dynamic_cast<const U4ITHit *>(obj)->GetLayerID();
         return (radius < radiuso ? -1 : (radius > radiuso ? 1 : 0));
      }
   }
}

//=====================================================================
//* Update ------------------------------------------------------------

void U4ITHit::Update()
{
   if (fDone) return;
   fDone = kTRUE;
   CalculatePosition();
}

//=====================================================================
//* CalculatePosition -------------------------------------------------

void U4ITHit::CalculatePosition()
{
}

//=====================================================================
//* DebugPrint --------------------------------------------------------

void U4ITHit::DebugPrint(const Char_t *opt)
{
}

