#ifndef __U4ITTRACK__
#define __U4ITTRACK__
//*************************************************************************
//* ---------------------
//* U4ITTrack Class
//* ---------------------
//* (Description)
//*	Class to store "U4ITTrackHit"s for a single layer.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4ITTrack		: Array containing "U4ITTrackHit"s
//* (Update Record)
//*	2004/09/06  A.Yamaguchi     Original version.
//*************************************************************************

#include "U4ITTrackMaker.h"
#include "U4VTrack.h"


class U4ITTrack : public U4VTrack {
public:
   // ----------------------------------------------------------------------
   // C-tors and D-tor 
   // ----------------
   U4ITTrack();
   U4ITTrack(U4ITTrackMaker *trkm);
   U4ITTrack(const U4ITTrack &tk);
   virtual ~U4ITTrack();
 
   // ----------------------------------------------------------------------
   // Service methods
   // ---------------
   virtual void  DebugPrint(const Char_t *opt = "Brief");
   virtual Int_t GetNhits  ();

   virtual void           MakeKalHits (TObjArray &kalhits);  
   virtual TKalTrackSite *GetFirstSitePtr(Bool_t dir, TObjArray *hitsp = 0);

   virtual void KalmanFilter(Bool_t dir = kIterBackward); 

  
  ClassDef(U4ITTrack, 1)                  // IT Track
};


#endif
