#ifndef __U4TPCTRACKHIT__
#define __U4TPCTRACKHIT__
//*************************************************************************
//* ---------------------
//* U4TPCTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single track hit.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4TPCTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "U4VTrackHit.h"
#include "U4TPCHit.h"

class U4TPCTrackHit : public U4VTrackHit {
friend class U4TPCTrack;
public:
  U4TPCTrackHit();
  U4TPCTrackHit(U4TPCHit *ht);
  U4TPCTrackHit(const U4TPCTrackHit &hit);
  virtual ~U4TPCTrackHit();

  static  void   SetSortBy (Char_t *opt = "PadRowNumber");
  virtual Bool_t IsSortable()                   const;
  virtual Int_t  Compare   (const TObject *obj) const;
       
  inline virtual U4TPCHit *GetHitPtr  () {
     return  dynamic_cast<U4TPCHit *> (U4VTrackHit::GetHitPtr());
  }


  ClassDef(U4TPCTrackHit, 1)       // TPC Hit
};


#endif
