#ifndef __U4VTXHITMAKERBUF__
#define __U4VTXHITMAKERBUF__
//*************************************************************************
//* ---------------------
//* U4VTXHitMakerBuf Class
//* ---------------------
//* (Description)
//*	This set of classes makes FADC clusters.
//* (Requires)
//*	JSFEventBuf
//* (Provides)
//*	U4VTXHitMakerBuf		: buffering class
//* (Update Record)
//*	2004/12/15  T.Fujikawa	Original version.
//*************************************************************************

#include "U4VHitMakerBuf.h"
#include "U4VTXHitMaker.h"


class U4VTXHitMakerBuf : public U4VHitMakerBuf {

public:

  U4VTXHitMakerBuf(const Char_t *name  = "U4VTXHitBuf",
	           const Char_t *title = "VTX Hit data", 
	           U4VTXHitMaker *module = 0, Int_t bufsize = 2000);
  U4VTXHitMakerBuf(U4VTXHitMaker *module,
	           const Char_t *name  = "U4VTXHitBuf",
	           const Char_t *title = "VTX Hit data",
	           Int_t bufsize = 2000);
		    
  virtual ~U4VTXHitMakerBuf();
  
  virtual void 	DebugPrint(const Char_t *opt = "");
  

protected:
  virtual void	MakeHits() ;	// Make VTX Hits
    

  ClassDef(U4VTXHitMakerBuf, 1) // PadHit data buffer
};



#endif
