#ifndef __U4VTXTRACKHVTX__
#define __U4VTXTRACKHVTX__
//*************************************************************************
//* ---------------------
//* U4VTXTrackHit Class
//* ---------------------
//* (Description)
//*	Class for a single track hit.
//* (Requires)
//*	TObjArray
//* (Provides)
//*	U4VTXTrackHit		: 
//* (Update Record)
//*	2004/08/26  A.Yamaguchi
//*************************************************************************

#include "U4VTrackHit.h"
#include "U4VTXHit.h"


class U4VTXTrackHit : public U4VTrackHit {
friend class U4VTXTrack;
public:
  U4VTXTrackHit();
  U4VTXTrackHit(U4VTXHit *ht);
  U4VTXTrackHit(const U4VTXTrackHit &hit);
  virtual ~U4VTXTrackHit();

  static  void   SetSortBy (Char_t *opt);
  virtual Int_t  Compare   (const TObject *obj) const;
       
  inline virtual U4VTXHit *GetHitPtr()
  {
     return  dynamic_cast<U4VTXHit *>(U4VTrackHit::GetHitPtr());
  }


  ClassDef(U4VTXTrackHit, 1)       // VTX Hit
};


#endif
